plugin simpleMeshMod Vu_Parse_Quads
	name:"Vu_Parse_Quads"
	classID:#(0x3D3BEC97, 0xD238D3)
	category:"Max Creation Graph"
(
	local pluginDefinitionFile -- the plugin definition file
	local pluginInstance -- the plugin instance created from the plugin definition
	local _meshWrapper -- the dotnet wrapper around the stack mesh pointer
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject
	local tmHandler

	-- function wrappers
	local _meshWrapper_SetValue
	local pluginInstance_UpdateMesh

	-- value wrapper local and function wrapper declarations
	local PickUnwrapperWrapper, PickUnwrapperWrapper_SetValue
	local meshWrapper, meshWrapper_SetValue


	parameters main rollout:params
	(
		UseUnwrap ui:UseUnwrap default:False type:#boolean animatable:true
		PickUnwrapper ui:PickUnwrapper type:#node useNodeOsValidity:true useNodeTmValidity:true
		Reverse ui:Reverse default:False type:#boolean animatable:true
		Grow ui:Grow default:True type:#boolean animatable:true
		Face_ ui:Face_ default:0 type:#integer animatable:true
		_dummy type:#boolean -- this exists to enable easy invalidation of the object        
		pluginGraph type:#filename assettype:#MaxCreationGraph readOnly:true enumAsAsset:true 
        pluginGraphDependencies type:#filenametab assettype:#MaxCreationGraph readOnly:true enumAsAsset:true tabSize:0 tabSizeVariable:true
    ) 

rollout params "Parameters"
	(

		checkbox Grow "Grow" checked:True
		spinner Face_ "Face:" range:[0, 9999999, 0] type:#integer
		checkbox Reverse "Reverse" checked:False

	group "Experimental !!!"
	(
		label lab11 "Use a plane as  Unwrapper" align:#left
		label lab12 "then tweak the res and" align:#left
		label lab13 "dimensions of Unwrapper." align:#left
		label lab14 "Then add Unwrap UVW mod" align:#left
		label lab15 "to see results..." align:#left
		checkbox UseUnwrap "Use Unwrapper" checked:False
		pickbutton PickUnwrapper "PickUnwrapper" autodisplay:true type:#node
	)
	)

rollout inforoll "About"
	(
		Group "Vu Rings Info"
		(
			label lab21 "Author: Vu Nguyen" align:#left
			label lab22 "(c) Vu Nguyen 2015" align:#left
			label lab24 "Version: 2.00.00" align:#left
			label lab25 "Email: vusta@hotmail.com" align:#left
		)

	)

	fn initialize = 
	(
		pluginDefinitionFile = @"C:/Users/Honey/Autodesk/3ds Max 2016/Max Creation Graph/Tools/Vu_Parse_Quads.maxtool"
		local c = dotNetClass "Viper3dsMaxBridge.ModifierPluginInstance"
		local cid = this.classId
		local refMakerWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.ReferenceMaker"
		refMakerWrapper = refMakerWrapperClass._CreateWrapper this
		pluginInstance = c.CreateInstance cid[1] cid[2] pluginDefinitionFile refMakerWrapper
		pluginInstance_UpdateMesh = pluginInstance.UpdateMesh
		local meshWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.Mesh"
		_meshWrapper = meshWrapperClass._CreateWrapper undefined
		_meshWrapper_SetValue = _meshWrapper._SetValue
		pluginGraph = pluginDefinitionFile
		pluginGraphDependencies = #(@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MultiplyByTwo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DivideByTwo.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\PlusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array2.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SkipOne.maxcompound")

		-- value wrapper local initializations
		local PickUnwrapperWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.INode"
		PickUnwrapperWrapper = PickUnwrapperWrapperClass._CreateWrapper (undefined)
		PickUnwrapperWrapper_SetValue = PickUnwrapperWrapper._SetValue
		local meshWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Mesh"
		meshWrapper = meshWrapperClass._CreateWrapper (undefined)
		meshWrapper_SetValue = meshWrapper._SetValue

	)

	fn updateMesh = 
	(

		if (pluginInstance == undefined) then ( return undefined )
		local args = dotnet_ValueToDotNetObject #(UseUnwrap, PickUnwrapperWrapper, Reverse, Grow, meshWrapper, Face_) argsType
		pluginInstance_UpdateMesh (currentTime as integer) _meshWrapper args
	)
	
	on modifyMesh do
	(
		try 
		(
			_meshWrapper_SetValue mesh
			PickUnwrapperWrapper_SetValue PickUnwrapper
			meshWrapper_SetValue mesh

			updateMesh()
			_meshWrapper_SetValue undefined

		)
		catch()
		ok
	)

	on create do 
	(
		initialize()
	)

	on clone fromObj do 
	(
		initialize()
	)

	on load do 
	(
		initialize()
	)

	on update do 
	(
		initialize()
	)
)
